Create multiple segments

Multiple segments can be defined one after another. To create a connector with multiple segments, define and add the segments to the [segments] collection. The following code example illustrates how to create a connector with multiple segments.

ej.diagrams.Diagram.Inject(ej.diagrams.ConnectorEditing);
var connectors = [
  {
    id: 'connector1',
    type: 'Orthogonal',
    // Defines multile segemnts for the connectors
    segments: [
      {
        type: 'Orthogonal',
        direction: 'Bottom',
        length: 150,
      },
      {
        type: 'Orthogonal',
        direction: 'Right',
        length: 150,
      },
      {
        type: 'Orthogonal',
        direction: 'Top',
        length: 100,
      },
      {
        type: 'Orthogonal',
        direction: 'Left',
        length: 100,
      },
    ],
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
      strokeWidth: 2,
    },
    targetDecorator: {
      style: {
        fill: '#6BA5D7',
        strokeColor: '#6BA5D7',
      },
    },
    sourcePoint: {
      x: 300,
      y: 100,
    },
    targetPoint: {
      x: 350,
      y: 150,
    },
    constraints:
      ej.diagrams.ConnectorConstraints.Default |
      ej.diagrams.ConnectorConstraints.DragSegmentThumb,
  },
  {
    id: 'connector2',
    type: 'Bezier',
    constraints:
      ej.diagrams.ConnectorConstraints.Default |
      ej.diagrams.ConnectorConstraints.DragSegmentThumb,
    segments: [
      { point: { x: 150, y: 150 }, type: 'Bezier' },
      { point: { x: 250, y: 250 }, type: 'Bezier' },
    ],
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 300 },
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
      strokeWidth: 2,
    },
    targetDecorator: {
      style: {
        fill: '#6BA5D7',
        strokeColor: '#6BA5D7',
      },
    },
  },
  {
    id: 'connector3',
    type: 'Straight',
    constraints:
      ej.diagrams.ConnectorConstraints.Default |
      ej.diagrams.ConnectorConstraints.DragSegmentThumb,
    segments: [
      { point: { x: 500, y: 200 }, type: 'Straight' },
      { point: { x: 600, y: 300 }, type: 'Straight' },
    ],
    sourcePoint: { x: 600, y: 100 },
    targetPoint: { x: 800, y: 300 },
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
      strokeWidth: 2,
    },
    targetDecorator: {
      style: {
        fill: '#6BA5D7',
        strokeColor: '#6BA5D7',
      },
    },
  },
];

var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    connectors: connectors,
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Undo/Redo support for connector segments

The Diagram control provides comprehensive undo and redo functionality for all connector segment operations. This includes reversible actions such as dragging, resizing, and rotating source or target nodes, as well as modifying segment points and endpoints.

Key undo/redo capabilities include:

  • Modifying and adjusting segment points.
  • Changing connector endpoints between nodes or ports.
  • Performing node operations that affect connected segments.
  • Adding, removing, or reordering segments.

This functionality ensures consistent editing behavior across all connector types and interactions, enabling users to experiment with complex routing configurations while retaining the ability to revert changes.

The following example demonstrates undo and redo functionality for connector segments:

import {
  Diagram,
  NodeModel,
  ConnectorModel,
  HierarchicalTree,
  ConnectorConstraints,
  ConnectorEditing, UndoRedo
} from '@syncfusion/ej2-diagrams';
Diagram.Inject(HierarchicalTree, ConnectorEditing, UndoRedo);
let nodes: NodeModel[] = [
 {
    id: 'sourcenode',
    width: 150,
    height: 50,
    offsetX: 350,
    offsetY: 50,
    annotations: [
      {
        content: 'Node1',
      },
    ],
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
  },
  {
    id: 'targetnode',
    width: 150,
    height: 50,
    offsetX: 200,
    offsetY: 250,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [
      {
        content: 'Node2',
      },
    ],
  },
];
let connectors: ConnectorModel[] = [
  {
    id: 'connector1',
    sourceID: 'sourcenode',
    targetID: 'targetnode',
    type: 'Orthogonal',
    segments: [
      {
        type: 'Orthogonal',
        direction: 'Left',
        length: 100,
      },
      {
        type: 'Orthogonal',
        direction: 'Bottom',
        length: 100
      },
      {
        type: 'Orthogonal',
        direction: 'Right',
        length: 100
      },
      {
        type: 'Orthogonal',
        direction: 'Bottom',
        length: 50
      }
    ],
    constraints:
      ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  },
];
let diagram: Diagram = new Diagram({
  width: '100%',
  height: '600px',
  nodes: nodes,
  connectors: connectors,
});
diagram.appendTo('#element');

(document.getElementById('undo') as HTMLInputElement).onclick = () => {
  diagram.undo();
};

(document.getElementById('redo') as HTMLInputElement).onclick = () => {
  diagram.redo();
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="Undo" id="undo" />
        <input type="button" value="Redo" id="redo" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Create multiple segments

Multiple segments can be defined one after another. To create a connector with multiple segments, define and add the segments to the segments collection. The following code example illustrates how to create a connector with multiple segments.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, ConnectorConstraints, ConnectorEditing } from '@syncfusion/ej2-vue-diagrams';

let connectors = [
{
  id: 'connector1',
  type: 'Orthogonal',
  // Defines multile segemnts for the connectors
  segments: [
    {
      type: 'Orthogonal',
      direction: 'Bottom',
      length: 150,
    },
    {
      type: 'Orthogonal',
      direction: 'Right',
      length: 150,
    },
    {
      type: 'Orthogonal',
      direction: 'Top',
      length: 100,
    },
    {
      type: 'Orthogonal',
      direction: 'Left',
      length: 100,
    },
  ],
  sourcePoint: {
    x: 300,
    y: 100,
  },
  targetPoint: {
    x: 350,
    y: 150,
  },
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
}, {
  id: 'connector2',
  type: 'Bezier',
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  segments: [
    { point: { x: 150, y: 150 }, type: 'Bezier' },
    { point: { x: 250, y: 250 }, type: 'Bezier' },
  ],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 300, y: 300 },
}, {
  id: 'connector3',
  type: 'Straight',
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  segments: [
    { point: { x: 500, y: 200 }, type: 'Straight' },
    { point: { x: 600, y: 300 }, type: 'Straight' },
  ],
  sourcePoint: { x: 600, y: 100 },
  targetPoint: { x: 800, y: 300 },
},
]

const width = "100%";
const height = "350px";

provide('diagram', [ConnectorEditing]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
    <ejs-diagram id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent,ConnectorConstraints,ConnectorEditing } from '@syncfusion/ej2-vue-diagrams';

let connectors = [
{
  id: 'connector1',
  type: 'Orthogonal',
  // Defines multile segemnts for the connectors
  segments: [
    {
      type: 'Orthogonal',
      direction: 'Bottom',
      length: 150,
    },
    {
      type: 'Orthogonal',
      direction: 'Right',
      length: 150,
    },
    {
      type: 'Orthogonal',
      direction: 'Top',
      length: 100,
    },
    {
      type: 'Orthogonal',
      direction: 'Left',
      length: 100,
    },
  ],
  sourcePoint: {
    x: 300,
    y: 100,
  },
  targetPoint: {
    x: 350,
    y: 150,
  },
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
}, {
  id: 'connector2',
  type: 'Bezier',
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  segments: [
    { point: { x: 150, y: 150 }, type: 'Bezier' },
    { point: { x: 250, y: 250 }, type: 'Bezier' },
  ],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 300, y: 300 },
}, {
  id: 'connector3',
  type: 'Straight',
  constraints:
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  segments: [
    { point: { x: 500, y: 200 }, type: 'Straight' },
    { point: { x: 600, y: 300 }, type: 'Straight' },
  ],
  sourcePoint: { x: 600, y: 100 },
  targetPoint: { x: 800, y: 300 },
  
},
]
export default {
name: "App",
components: {
"ejs-diagram": DiagramComponent
},
data() {
return {
    width: "100%",
    height: "350px",
    connectors: connectors
}
}, provide: {
diagram: [ConnectorEditing]
}
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Undo/Redo support for connector segments

The Diagram control provides comprehensive undo and redo functionality for all connector segment operations. This includes reversible actions such as dragging, resizing, and rotating source or target nodes, as well as modifying segment points and endpoints.

Key undo/redo capabilities include:

  • Modifying and adjusting segment points.
  • Changing connector endpoints between nodes or ports.
  • Performing node operations that affect connected segments.
  • Adding, removing, or reordering segments.

This functionality ensures consistent editing behavior across all connector types and interactions, enabling users to experiment with complex routing configurations while retaining the ability to revert changes.

The following example demonstrates undo and redo functionality for connector segments:

<template>
  <div id="app">
    <button @click="undo">Undo</button>
    <button @click="redo">Redo</button>
    <ejs-diagram id="diagram" :width="width" :height="height" :nodes="nodes" :connectors="connectors"></ejs-diagram>
  </div>
</template>

<script setup>

import {
  DiagramComponent as EjsDiagram,
  ConnectorConstraints,
  ConnectorEditing,
  UndoRedo,
} from "@syncfusion/ej2-vue-diagrams";
import { provide } from "vue";

const width = "100%";
const height = "350px";
const nodes = [
  {
    id: "sourcenode",
    width: 150,
    height: 50,
    offsetX: 350,
    offsetY: 50,
    annotations: [
      {
        content: "Node1",
      },
    ],
    style: {
      fill: "#6BA5D7",
      strokeColor: "white",
    },
  },
  {
    id: "targetnode",
    width: 150,
    height: 50,
    offsetX: 200,
    offsetY: 250,
    style: {
      fill: "#6BA5D7",
      strokeColor: "white",
    },
    annotations: [
      {
        content: "Node2",
      },
    ],
  },
];
const connectors = [
  {
    id: "connector1",
    sourceID: "sourcenode",
    targetID: "targetnode",
    type: "Orthogonal",
    segments: [
      {
        type: "Orthogonal",
        direction: "Left",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Bottom",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Right",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Bottom",
        length: 50,
      },
    ],
    constraints: ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  },
];
const undo = function () {
  diagram.value.ej2Instances.undo();
};
const redo = function () {
  diagram.value.ej2Instances.redo();
};

provide: {
  diagram: [ConnectorEditing, UndoRedo];
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <button @click="undo">Undo</button>
    <button @click="redo">Redo</button>
    <ejs-diagram ref="diagram" :width="width" :height="height" :nodes="nodes" :connectors="connectors"></ejs-diagram>
  </div>
</template>

<script>

import {
  DiagramComponent,
  ConnectorConstraints,
  ConnectorEditing,
  UndoRedo,
} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "sourcenode",
    width: 150,
    height: 50,
    offsetX: 350,
    offsetY: 50,
    annotations: [
      {
        content: "Node1",
      },
    ],
    style: {
      fill: "#6BA5D7",
      strokeColor: "white",
    },
  },
  {
    id: "targetnode",
    width: 150,
    height: 50,
    offsetX: 200,
    offsetY: 250,
    style: {
      fill: "#6BA5D7",
      strokeColor: "white",
    },
    annotations: [
      {
        content: "Node2",
      },
    ],
  },
];
let connectors = [
  {
    id: "connector1",
    sourceID: "sourcenode",
    targetID: "targetnode",
    type: "Orthogonal",
    segments: [
      {
        type: "Orthogonal",
        direction: "Left",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Bottom",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Right",
        length: 100,
      },
      {
        type: "Orthogonal",
        direction: "Bottom",
        length: 50,
      },
    ],
    constraints: ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
  },
];
export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      connectors: connectors,
    };
  },
  methods: {
    undo() {
      this.$refs.diagram.ej2Instances.undo();
    },
    redo() {
      this.$refs.diagram.ej2Instances.redo();
    },
  },
  provide: {
    diagram: [ConnectorEditing, UndoRedo],
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Multiple Segments for Connectors

Connectors in the Angular Diagram component can be composed of multiple segments to create complex routing paths between nodes. Multiple segments allow you to define precise connection routes that navigate around obstacles or follow specific pathways in your diagram layout.

Understanding Connector Segments

A connector segment represents a portion of the connector’s path. By combining multiple segments, you can create connectors that change direction multiple times, forming L-shapes, Z-shapes, or more complex routing patterns. Each segment can have different properties and behaviors depending on the segment type used.

Create Multiple Segments

Multiple segments can be defined sequentially to form a complete connector path. To create a connector with multiple segments, define and add the segments to the segments collection.

The following example demonstrates how to create a connector with multiple segments that forms a custom routing path:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, ConnectorModel, ConnectorEditing, ConnectorConstraints } from '@syncfusion/ej2-angular-diagrams';
Diagram.Inject(ConnectorEditing);

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [connectors]='connectors'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;
    public connectors: ConnectorModel[] = [
        {
            id: 'connector1',
            type: 'Orthogonal',
            segments: [{
                type: 'Orthogonal',
                direction: 'Bottom',
                length: 150,
            },
            {
                type: 'Orthogonal',
                direction: 'Right',
                length: 150,
            },
            {
                type: 'Orthogonal',
                direction: 'Top',
                length: 100,
            },
            {
                type: 'Orthogonal',
                direction: 'Left',
                length: 100,
            }],
            sourcePoint: { x: 300, y: 100 },
            targetPoint: { x: 350, y: 150 },
            constraints: ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb
        },
        {
            id: 'connector2',
            type: 'Bezier',
            constraints: ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
            segments: [
                { point: { x: 150, y: 150 }, type: 'Bezier' },
                { point: { x: 250, y: 250 }, type: 'Bezier' },
            ],
            sourcePoint: { x: 100, y: 100 },
            targetPoint: { x: 300, y: 300 },
        },
        {
            id: 'connector3',
            type: 'Straight',
            constraints: ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb,
            segments: [
                { point: { x: 500, y: 200 }, type: 'Straight' },
                { point: { x: 600, y: 300 }, type: 'Straight' },
            ],
            sourcePoint: { x: 600, y: 100 },
            targetPoint: { x: 800, y: 300 },
        }
    ];

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Use cases

Multiple segments are particularly useful for:

  • Creating connectors that route around obstacles or other nodes
  • Designing flowcharts with specific directional requirements
  • Building network diagrams with custom connection paths
  • Implementing organizational charts with complex hierarchical connections

Undo/Redo support for connector segments

The Diagram control provides comprehensive undo and redo functionality for all connector segment operations. This includes reversible actions such as dragging, resizing, and rotating source or target nodes, as well as modifying segment points and endpoints.

Key undo/redo capabilities include:

  • Modifying and adjusting segment points.
  • Changing connector endpoints between nodes or ports.
  • Performing node operations that affect connected segments.
  • Adding, removing, or reordering segments.

This functionality ensures consistent editing behavior across all connector types and interactions, enabling users to experiment with complex routing configurations while retaining the ability to revert changes.

The following example demonstrates undo and redo functionality for connector segments:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
  DiagramComponent,
  Diagram,
  OrthogonalSegmentModel,
  ConnectorEditing,
  ConnectorConstraints,
  DiagramModule,
  ShapeStyleModel,
  UndoRedo,
} from '@syncfusion/ej2-angular-diagrams';
Diagram.Inject(ConnectorEditing, UndoRedo);

@Component({
  imports: [DiagramModule],
  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `
    <button (click)="undo()">Undo</button>
    <button (click)="redo()">Redo</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="600px">
          <e-nodes>
              <e-node id='sourcenode' [offsetX]=350 [offsetY]=50 [width]=150 [height]=50  [style]='style'>
                  <e-node-annotations>
                          <e-node-annotation content="node 1">
                          </e-node-annotation>
                  </e-node-annotations>
              </e-node>
              <e-node id='targetnode' [offsetX]=200 [offsetY]=250 [width]=150 [height]=50 [style]='style'>
                  <e-node-annotations>
                          <e-node-annotation content="node 2">
                          </e-node-annotation>
                  </e-node-annotations>
              </e-node>
          </e-nodes>
          <e-connectors>
              <e-connector id='connector' type='Orthogonal' sourceID='sourcenode' targetID='targetnode' [constraints]='constraints' [segments]='segments'>
              </e-connector>
          </e-connectors>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public segments?: OrthogonalSegmentModel;
  public style?: ShapeStyleModel;

  ngOnInit(): void {
    this.segments = [
      {
        type: 'Orthogonal',
        direction: 'Left',
        length: 100,
      },
      {
        type: 'Orthogonal',
        direction: 'Bottom',
        length: 100,
      },
      {
        type: 'Orthogonal',
        direction: 'Right',
        length: 100,
      },
      {
        type: 'Orthogonal',
        direction: 'Bottom',
        length: 50,
      },
    ];
    this.style = {
      fill: '#6BA5D7',
      strokeColor: 'white',
    };
  }
  constraints = ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb;
  undo() {
    (this.diagram as any).undo();
  }
  redo() {
    (this.diagram as any).redo();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));